<?php
/*
+------------------------------------------------------------------------------+
| Compteur par appel JavaScript, multivisiteurs (plusieurs IP)                 |
| TT , version 5.4  du 15 novembre 2009                                        |
| insertion du compteur dans le code HTML de la page, par une ligne javascript:|
|<script language="JavaScript" type="text/javascript" src="@"></script>        |
| avec "@" l'adresse relative ou absolue de ce fichier PHP                     |
+------------------------------------------------------------------------------+
*/
//--- Initialisation de variables (Vous pouvez personnaliser ces variables) ---/
$sgn= 'Compteur TTU v5.4';      // commentaire, 17 caractres
$controldomaine= 'non';         // contrle le domaine suivant le tableau $Domaines
$Domaines= array('');           // domaines o le compteur est oprationnel
$Ipwebmaster= array('');        // IP qui ne seront pas considrs
$delai= 600;                    // delai en s pour le considrer comme nouveau
$afficheip= 'non';              // affiche le nIP du visiteur (oui/non)
$affichenv= 'oui';              // affiche le nombre de visiteurs en cours
$local= 'non';                  // est-ce pour tout le site > non, si que la page > oui
$fichiercompteur= 'cptmip.txt'; // fichier de donnes du compteur
$cmtjs= '---------';            // affichage compteur en cas de PB
//-----------------------------------------------------------------------------/
//
$host= $_SERVER['HTTP_HOST'];   // nom du domaine du site
if (($controldomaine=='oui') AND (!in_array($host,$Domaines))){
    echo('document.write(\'--- non disponible ---\');');
    exit; // arrt du script PHP si le domaine n'est pas permis
}
//
$ipv= $_SERVER['REMOTE_ADDR'];  // numro IP du visiteur
$ipvf= sprintf('%15s',$ipv);
$chrono= sprintf('%10s',time());// date de visite (en secondes)
// le visiteur en cours (except pour certaines IP) est considr par dfaut comme "nouveau"
(in_array($ipv,$Ipwebmaster))? $nouveau= 0: $nouveau= 1;
//
$nvpmax= 0;
if (!file_exists($fichiercompteur)) touch($fichiercompteur);
// lecture du fichier de comptage, $n+1 lignes
if ($pf0=fopen($fichiercompteur,'r+')){
    $i= 0;
    while (!feof($pf0)){
        $Ligne[$i++]= fgets($pf0,1024);
    }
    $n= $i-2; // $n visiteurs dans la liste, la dernire ligne contient $nvpmax
    $nvpmax= substr($Ligne[$n+1],1,5); // rcupration de $nvpmax
    //
    // analyse du fichier compteur et traitement
    $cmp= substr($Ligne[0],1,8); // rcupration du dcompte de visiteurs
    // rcupration des infos sur les $n visiteurs dj recencs
    for ($i=1;$i<=$n;$i++){
        $Ipvs[$i]= substr($Ligne[$i],1,15);     // IP du visiteur $i
        $Chronos[$i]= substr($Ligne[$i],17,10); // date de sa dernire visite
        $present[$i]= 1; // le visiteur $i est suppos prsent
        // si la date du visiteur $i est prime, il n'est plus considr prsent
        if (($chrono-$Chronos[$i])>$delai) $present[$i]= 0;
        // si le visiteur $i est le visiteur en cours ET est considr prsent
        // alors il n'est pas nouveau et sa date de visite est mise  jour
        if (($Ipvs[$i]==$ipvf) AND ($present[$i]==1)){
            $nouveau= 0; $Chronos[$i]= $chrono;
        }
    }
    // si le visiteur en cours est toujours considr comme nouveau,
    // il est ajout  la liste et le compteur est incrment
    if ($nouveau==1){
        $i= ++$n; $cmp++;
        $present[$i]= 1; $Ipvs[$i]= $ipvf; $Chronos[$i]= $chrono;
    }
    // mise  jour du fichier compteur
    rewind($pf0); ftruncate($pf0,0);
    $cmpf= sprintf('%08s',$cmp);
    fwrite($pf0,':'.$cmpf.':'.$sgn.':'.chr(10));
    $nvp= 0; // $nvp : nombre de visiteurs en liste, supposs prsents
    for ($i=1;$i<=$n;$i++){
        if ($present[$i]==1){
            fwrite($pf0,':'.$Ipvs[$i].':'.$Chronos[$i].':'.chr(10));
            $nvp++;
        }
    }
    if ($nvp>$nvpmax) $nvpmax= $nvp;
    $nvpmaxf= sprintf('%05s',$nvpmax);
    fwrite($pf0,':'.$nvpmaxf.': pointe visites maxi:');
    fclose($pf0 );
    //
    // gnration du contenu HTML, chaine $cmtjs
    $cmtjs= '<span class="totalvisites">&nbsp;'.$cmpf.' visiteurs</span>';
    if ($afficheip=='oui'){
        $cmtjs.= ',&nbsp;<span class="ipvisiteur">votre n&#176;IP est '.$ipv.'</span>';
    }
    if ($affichenv=='oui'){
        $pl=($nvp<=1)? '': 's';
        ($local=='oui')? $txt= ' sur la page': $txt= ' sur le site';
        $cmtjs.= '&nbsp;-&nbsp;<span class="visitesencours">actuellement '.$nvp.' visiteur'.$pl.$txt.'</span>';
    }
    if (in_array($ipv,$Ipwebmaster)){
        $cmtjs.= '&nbsp;(&nbsp;pointe de visites&nbsp;=&nbsp;'.$nvpmax.'&nbsp;)';
    }
}
// envoi du rsultat pour affichage sur la page
echo('document.write(\''.$cmtjs.'&nbsp;\');');
?>
